c------------------------------------------c
c Exercise: Circular Shift
c
c In this exercise you will communicate a matrix 
c among process in a circular topology, so that
c every process has a left and a right neighbor
c to receive and to send data respectivelly.
c
c Check what happens for huge size of the message
c------------------------------------------c

      program main


      implicit none

      include 'mpif.h'
      integer i
      integer ierr,rank,size
      integer tag,from,to
      integer MSIZE
c--- try to change MSIZE with 500, 5000 and 50000 ---      
c--- does it work for all these sizes? What happens ?
      parameter(MSIZE=500)
      integer A(MSIZE),B(MSIZE)

      integer status(MPI_STATUS_SIZE)
      




      
c--- Start up MPI  ----------- ----------------------------------------------
      call MPI_INIT(ierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD,rank,ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD,size,ierr)

c----- print banner --------------------------------------------------------c
      if (rank.eq.0) then
         print *
     $        ,'Circular shift example: each process fills matrix A' 
         print *
     $        ,'elements with its rank and sends them to the right'
         
         print *,'process which receives them into matrix B'
         PRINT *,' '
      endif
    
c---------------------------------------------------------------------------c
c    Arbitrarily choose 201 to be our tag. Calculate the rank of the        c
c    to process. Use the modulus operator so that the                     c
c    last process "wraps around" to rank zero.                              c
c---------------------------------------------------------------------------c

      tag=201
      to = mod(rank + 1,size)
      from = mod(rank + size - 1,size)

      do i=1,MSIZE
         A(i)=rank
      enddo 

c--- starting send of array A  ----------------------------------------------

      CALL MPI_SEND(A,MSIZE, MPI_INTEGER,to,tag,MPI_COMM_WORLD
     $     ,ierr)
      print '(a4,2x,i4,2x,a8,2x,i4,2x,a16,2x,i4)','Proc',rank,'sends   '
     $     ,MSIZE,'integers to proc',to

c--- starting receives of array A in B --------------------------------------

     
      CALL MPI_RECV(B, MSIZE, MPI_INTEGER, from, tag
     $     ,MPI_COMM_WORLD, status, ierr)
      print '(a4,2x,i4,2x,a8,2x,i4,2x,a16,2x,i4)','Proc',rank,'receives'
     $     ,MSIZE,'integers from proc',from



c--- print first content of array A and B -----------------------------------

      print '(a4,2x,i4,2x,a10,2x,i4,2x,a10,i4)','Proc',rank,'has A(1) ='
     $     ,A(1),' and B(1)=',B(1)
      print *,'**************************************'

c--- QUIT -------------------------------------------------------------------
      
      call MPI_FINALIZE(ierr)
      
      end
